﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO.Ports;
using System.Runtime.InteropServices;
using Modbus.Device;

namespace modbusrtu_master_tm
{
    public partial class Form1 : Form
    {
        SerialPort serialPort = new SerialPort();
        ModbusSerialMaster master;

        //Paint parameter
        const int DI_MAX_TOTAL_CH = 8;
        const int DO_MAX_TOTAL_CH = 8;
        const int AI_MAX_TOTAL_CH = 8;
        const int AO_MAX_TOTAL_CH = 8;

        const int VerticalDIAMETER = 15;
        const int HorizonDIAMETER = 60;
        const int GAP_CIRCLE_LABEL = 5;
        const int LABEL_WIDTH = 60;
        const int LABEL_HEIGHT = 20;
        const int GAP_DI_DO = 80;
        const int GAP_AI_AO = 40;
        const int GAP_AO_DI = 60;
        const int PitcureBox_WIDTH = 60;
        const int PitcureBox_HEIGHT = 60;
        const int TextBox_WIDTH = 75;
        const int TextBox_HEIGHT = 30;
        const int Label_WIDTH = 60;
        const int Label_HEIGHT = 30;
        const int GAP_HORIZONTAL = 30;
        //IO Channel
        private ushort total_DI_Ch = 0;
        private ushort total_DO_Ch = 0;
        private ushort total_AI_Ch = 0;
        private ushort total_AO_Ch = 0;
        //DIO Button
        PictureBox[] pbDI = new PictureBox[DI_MAX_TOTAL_CH];
        PictureBox[] pbDO = new PictureBox[DO_MAX_TOTAL_CH];
        bool[] status = new bool[DI_MAX_TOTAL_CH];
        bool[] coilstatus = new bool[DO_MAX_TOTAL_CH];
        //AO Text
        TextBox[] tbAO = new TextBox[AO_MAX_TOTAL_CH];
        Label[] lbAO = new Label[AO_MAX_TOTAL_CH];
        ushort[] holdingregister = new ushort[AO_MAX_TOTAL_CH];
        ushort[] AOunit = new ushort[AO_MAX_TOTAL_CH];
        string AOunits = "";
        //AI Lable
        Label[] lbAI = new Label[AI_MAX_TOTAL_CH];
        ushort[] register = new ushort[AI_MAX_TOTAL_CH];
        Label[] lbAIunit = new Label[AI_MAX_TOTAL_CH];
        ushort[] register_unit = new ushort[AI_MAX_TOTAL_CH];
        ushort sw;
        bool[] Format = new bool[2];

        private FontStyle fs;
        private FontFamily fm;
        private Font fo;
        private float fsize = 15;
        private byte slaveID;

        public Form1()
        {
            InitializeComponent();
            
            for (int i = 0; i < DO_MAX_TOTAL_CH; i++)
            {
                pbDO[i] = new PictureBox();
                //pbDO[i].CheckStateChanged += new System.EventHandler(this.checkBox_CheckStateChanged);
                pbDO[i].Click += new EventHandler(pbDO_Click);
                pbDO[i].Tag = i;
                this.panelIO.Controls.Add(pbDO[i]);
            }
            for (int i = 0; i < DI_MAX_TOTAL_CH; i++)
            {
                pbDI[i] = new PictureBox();
                this.panelIO.Controls.Add(pbDI[i]);
            }
            for (int i = 0; i < AI_MAX_TOTAL_CH; i++)
            {
                lbAI[i] = new Label();
                lbAIunit[i] = new Label();
                //fs = lbAI[i].Font.Style;
                fm = new FontFamily(lbAI[i].Font.Name);
                fo = new Font(fm,fsize,FontStyle.Bold);
                lbAI[i].Font = fo;
                lbAI[i].TextAlign = ContentAlignment.MiddleRight;
                lbAIunit[i].Font = fo;
                lbAIunit[i].TextAlign = ContentAlignment.MiddleRight;
                this.panelIO.Controls.Add(lbAI[i]);
                this.panelIO.Controls.Add(lbAIunit[i]);
            }
            for (int i = 0; i < AO_MAX_TOTAL_CH; i++)
            {
                lbAO[i] = new Label();
                tbAO[i] = new TextBox();
                //fs = tbAO[i].Font.Style;
                fm = new FontFamily(tbAO[i].Font.Name);
                fo = new Font(fm,fsize,FontStyle.Bold);
                lbAO[i].Font = fo;
                tbAO[i].Font = fo;
                //tbAO[i].KeyDown += new KeyEventHandler(tbAO_KeyDown);
                lbAO[i].Text = "";
                this.panelIO.Controls.Add(lbAO[i]);
                //tbAO[i].Click += new EventHandler(tbAO_Click);
                tbAO[i].MouseDown += new MouseEventHandler(tbAO_Click);
                tbAO[i].Tag = i;
                tbAO[i].Text = "0";
                tbAO[i].TextAlign = HorizontalAlignment.Right;
                this.panelIO.Controls.Add(tbAO[i]);
            }
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            //Get number of COM port and  assign COM port name to list in cmbComPort.
            foreach (string s in SerialPort.GetPortNames())
            {
                cbCom.Items.Add(s);
            }
            tbSID.Text = "1";
            cbCom.SelectedIndex = 0;
            cbTmModules.SelectedIndex = 0;
            cbDataBit.SelectedIndex = 0;
            cbParity.SelectedIndex = 0;
            cbStopBit.SelectedIndex = 0;
            cbBaud.SelectedIndex = 0;
            btOpenCom.Enabled = true;
            btCloseCom.Enabled = false;
            for (int i = 0; i < AO_MAX_TOTAL_CH; i++)
            {
                tbAO[i].Enabled = false;
            }
            for (int i = 0; i < DO_MAX_TOTAL_CH; i++)
            {
                pbDO[i].Enabled = false;
            }
        }

        private void cbTmModules_SelectedIndexChanged(object sender, EventArgs e)
        {        
            switch (cbTmModules.Text)
            {
                case "tM-AD2":
                    total_AI_Ch = 2;
                    total_AO_Ch = 0;
                    total_DI_Ch = 0;
                    total_DO_Ch = 0;
                    
                    break;
                case "tM-AD5":
                case "tM-AD5C":
                    total_AI_Ch = 5;
                    total_AO_Ch = 0;
                    total_DI_Ch = 0;
                    total_DO_Ch = 0;
                    break;
                case "tM-P4A4":
                case "tM-P4C4":
                    total_AI_Ch = 0;
                    total_AO_Ch = 0;
                    total_DI_Ch = 4;
                    total_DO_Ch = 4;
                    break;
                case "tM-AD8":
                case "tM-AD8C":
                case "tM-TH8":
                    total_AI_Ch = 8;
                    total_AO_Ch = 0;
                    total_DI_Ch = 0;
                    total_DO_Ch = 0;
                    break;
                case "tM-C8":
                    total_AI_Ch = 0;
                    total_AO_Ch = 0;
                    total_DI_Ch = 0;
                    total_DO_Ch = 8;
                    break;
                case "tM-P8":
                    total_AI_Ch = 0;
                    total_AO_Ch = 0;
                    total_DI_Ch = 8;
                    total_DO_Ch = 0;
                    break;
                case "tM-DA1P1R1":
                    total_AI_Ch = 0;
                    total_AO_Ch = 1;
                    total_DI_Ch = 1;
                    total_DO_Ch = 1;
                    break;
                case "tM-AD4P2C2":
                    total_AI_Ch = 4;
                    total_AO_Ch = 0;
                    total_DI_Ch = 2;
                    total_DO_Ch = 2;
                    break;
                case "tM-P3R3":
                case "tM-P3POR3":
                    total_AI_Ch = 0;
                    total_AO_Ch = 0;
                    total_DI_Ch = 3;
                    total_DO_Ch = 3;
                    break;
                case "tM-R5":
                    total_AI_Ch = 0;
                    total_AO_Ch = 0;
                    total_DI_Ch = 0;
                    total_DO_Ch = 5;
                    break;
            }

            printDO(total_DO_Ch);
            prinDI(total_DI_Ch);
            prinAI(total_AI_Ch);
            prinAO(total_AO_Ch);
        }


        #region DIO Paint

        private void printDO(int channel)
        {
            int x = 10;
            int y = 10 + VerticalDIAMETER + GAP_CIRCLE_LABEL + LABEL_HEIGHT + GAP_DI_DO + GAP_AI_AO + GAP_AO_DI;
            int vertical_shift = VerticalDIAMETER + GAP_CIRCLE_LABEL + LABEL_HEIGHT
                                       + GAP_DI_DO + PitcureBox_HEIGHT + GAP_DI_DO;
            int horizontal_shift = HorizonDIAMETER + GAP_HORIZONTAL;

            for (int i = 0; i < channel; i++)
            {
                pbDO[i].Location = new Point(x + horizontal_shift * (i % 8), y + vertical_shift * (i / 8));
                pbDO[i].Size = new Size(PitcureBox_WIDTH, PitcureBox_HEIGHT);
                pbDO[i].BackColor = Color.DarkRed;
                pbDO[i].Visible = true;
            }

            for (int j = channel; j < DO_MAX_TOTAL_CH; j++)
            {
                pbDO[j].Visible = false;
            }
        }
        private void prinDI(int channel)
        {
            int x = 10;
            int y = 10 + VerticalDIAMETER + GAP_CIRCLE_LABEL + GAP_AO_DI + GAP_AI_AO;
            int vertical_shift = VerticalDIAMETER + GAP_CIRCLE_LABEL + LABEL_HEIGHT
                                       + GAP_DI_DO + PitcureBox_HEIGHT + GAP_DI_DO;
            int horizontal_shift = HorizonDIAMETER + GAP_HORIZONTAL;

            for (int i = 0; i < channel; i++)
            {
                pbDI[i].Location = new Point(x + horizontal_shift * (i % 8), y + vertical_shift * (i / 8));
                pbDI[i].Size = new Size(PitcureBox_WIDTH, PitcureBox_HEIGHT);
                pbDI[i].BackColor = Color.DarkRed;
                pbDI[i].Visible = true;
            }

            for (int j = channel; j < DO_MAX_TOTAL_CH; j++)
            {
                pbDI[j].Visible = false;
            }
        }
        private void prinAO(int channel)
        {
            int x = 10;
            int y = 10 + VerticalDIAMETER + GAP_CIRCLE_LABEL + GAP_AI_AO;
            int vertical_shift = VerticalDIAMETER + GAP_CIRCLE_LABEL + LABEL_HEIGHT
                                       + GAP_DI_DO + TextBox_HEIGHT + GAP_DI_DO;
            int horizontal_shift = HorizonDIAMETER + GAP_HORIZONTAL;

            for (int i = 0; i < channel; i++)
            {
                tbAO[i].Location = new Point(x + horizontal_shift * (i % 8), y + vertical_shift * (i / 8) - 5);
                tbAO[i].Size = new Size(TextBox_WIDTH, TextBox_HEIGHT);
                tbAO[i].Visible = true;

                lbAO[i].Location = new Point(x + 80 + horizontal_shift * (i % 8), y + vertical_shift * (i / 8) - 5);
                lbAO[i].Size = new Size(Label_WIDTH, Label_HEIGHT);
                lbAO[i].Text = "";
                lbAO[i].Visible = true;
            }

            for (int j = channel; j < AO_MAX_TOTAL_CH; j++)
            {
                tbAO[j].Visible = false;
                lbAO[j].Visible = false;
            }
        }
        private void prinAI(int channel)
        {
            int x = 10;
            int y = 10 + VerticalDIAMETER + GAP_CIRCLE_LABEL;
            int vertical_shift = VerticalDIAMETER + GAP_CIRCLE_LABEL + LABEL_HEIGHT
                                       + GAP_DI_DO + Label_HEIGHT + GAP_AI_AO;
            int horizontal_shift = HorizonDIAMETER + GAP_HORIZONTAL + 10;

            for (int i = 0; i < channel; i++)
            {
                lbAI[i].Location = new Point(x + horizontal_shift * (i % 8), y + vertical_shift * (i / 8));
                lbAI[i].Size = new Size(65, Label_HEIGHT);
                lbAI[i].Text = "0.000";                
                lbAI[i].Visible = true;

                lbAIunit[i].Location = new Point(x + 60 + horizontal_shift * (i % 8), y + vertical_shift * (i / 8));
                lbAIunit[i].Size = new Size(40, Label_HEIGHT);
                lbAIunit[i].Text = "";
                lbAIunit[i].Visible = true;
            }

            for (int j = channel; j < AI_MAX_TOTAL_CH; j++)
            {
                lbAI[j].Visible = false;
                lbAIunit[j].Visible = false;
            }
        }
        #endregion

        private void btOpenCom_Click(object sender, EventArgs e)
        {
            serialPort.PortName = cbCom.SelectedItem.ToString();
            serialPort.BaudRate = int.Parse(cbBaud.SelectedItem.ToString());
            serialPort.DataBits = int.Parse(cbDataBit.SelectedItem.ToString());            

            if (cbParity.SelectedIndex == 0)
                serialPort.Parity = Parity.None;
            else if (cbParity.SelectedIndex == 1)
                serialPort.Parity = Parity.Even;
            else
                serialPort.Parity = Parity.Odd;

            if (cbStopBit.SelectedIndex == 0)
                serialPort.StopBits = StopBits.One;
            else
                serialPort.StopBits = StopBits.Two;

            try
            {
                serialPort.Open();
                master = ModbusSerialMaster.CreateRtu(serialPort);
                master.Transport.Retries = 0;
                master.Transport.ReadTimeout = 300;
                slaveID = Convert.ToByte(tbSID.Text, 16);
                cbCom.Enabled = false;
                cbBaud.Enabled = false;
                cbDataBit.Enabled = false;
                cbParity.Enabled = false;
                cbStopBit.Enabled = false;
                tbSID.Enabled = false;
                cbTmModules.Enabled = false;
                btOpenCom.Enabled = false;
                btCloseCom.Enabled = true;
                timer1.Enabled = true;

                if (total_AO_Ch > 0)
                {
                    AOunit = master.ReadHoldingRegisters(slaveID, 416, total_AO_Ch);
                }
                if (total_AI_Ch > 0)
                {
                    if (cbTmModules.Text == "tM-AD2")
                        register_unit = master.ReadHoldingRegisters(slaveID, 256, 2);
                    else if (cbTmModules.Text == "tM-TH8")
                        register_unit = master.ReadHoldingRegisters(slaveID, 256, 8);
                    else if (cbTmModules.Text == "tM-AD4P2C2")
                        register_unit = master.ReadHoldingRegisters(slaveID, 256, 4);
                    else
                        register_unit = master.ReadHoldingRegisters(slaveID, 486, 1);
                }
                for (int i = 0; i < total_AO_Ch; i++)
                {
                    tbAO[i].Enabled = true;
                    switch (AOunit[i])
                    {
                        case 0:
                        case 1:
                            lbAO[i].Text = "mA";
                            break;
                        case 2:
                        case 4:
                            lbAO[i].Text = "V";
                            break;
                        default:
                            break;
                    }
                }
                for (int i = 0; i < total_DO_Ch; i++)
                {
                    pbDO[i].Enabled = true;
                }
                for (int i = 0; i < total_AI_Ch; i++)
                {
                    if ((cbTmModules.Text == "tM-AD2") || (cbTmModules.Text == "tM-TH8") || (cbTmModules.Text == "tM-AD4P2C2"))
                        sw = register_unit[i];                    
                    else
                        sw = register_unit[0];
                    switch (sw)
                    {
                        case 0x05:
                        case 0x08:
                        case 0x09:
                        case 0x0A:
                            lbAIunit[i].Text = "V";
                            break;
                        case 0x06:
                        case 0x07:
                        case 0x0D:
                        case 0x1A:
                            lbAIunit[i].Text = "mA";
                            break;
                        case 0x0B:
                            lbAIunit[i].Text = "mV";
                            break;
                        case 0x60:
                            lbAIunit[i].Text = "°F";
                            break;
                        case 0x61:
                        case 0x62:
                        case 0x63:
                        case 0x64:
                        case 0x65:
                        case 0x66:
                        case 0x67:
                        case 0x68:
                        case 0x69:
                        case 0x6A:
                        case 0x6B:
                        case 0x6C:
                        case 0x70:
                        case 0x71:
                        case 0x72:
                        case 0x73:
                        case 0x74:
                        case 0x75:
                        case 0x76:
                        case 0x77:
                            lbAIunit[i].Text = "°C";
                            break;
                        default:
                            break;
                    }
                }
            }
            catch (Exception ex)
            {
                Console.WriteLine("Error" + ex.Message);
            }
        }

        private void btCloseCom_Click(object sender, EventArgs e)
        {
            serialPort.Close();
            cbCom.Enabled = true;
            cbBaud.Enabled = true;
            cbDataBit.Enabled = true;
            cbParity.Enabled = true;
            cbStopBit.Enabled = true;
            tbSID.Enabled = true;
            cbTmModules.Enabled = true;
            btOpenCom.Enabled = true;
            btCloseCom.Enabled = false;
            timer1.Enabled = false;
            for (int i = 0; i < AO_MAX_TOTAL_CH; i++)
            {
                tbAO[i].Enabled = false;
            }
            for (int i = 0; i < DO_MAX_TOTAL_CH; i++)
            {
                pbDO[i].Enabled = false;
            }
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            try
            {
                #region DI(1xxxx)
                if (total_DI_Ch > 0)
                {
                    status = master.ReadInputs(slaveID, 32, total_DI_Ch);
                    for (int i = 0; i < total_DI_Ch; i++)
                    {
                        if (status[i] == true)
                            pbDI[i].BackColor = Color.LightGreen;
                        else
                            pbDI[i].BackColor = Color.DarkRed;
                    }
                }
                #endregion
                #region DO(0xxxx)
                if (total_DO_Ch > 0)
                {
                    coilstatus = master.ReadCoils(slaveID, 0, total_DO_Ch);
                    for (int i = 0; i < total_DO_Ch; i++)
                    {
                        if (coilstatus[i] == true)
                            pbDO[i].BackColor = Color.LightGreen;
                        else
                            pbDO[i].BackColor = Color.DarkRed;
                    }
                }
                #endregion
                #region AI(3xxxx)
                if (total_AI_Ch > 0)
                {
                    register = master.ReadInputRegisters(slaveID, 0, total_AI_Ch);
                    for (int i = 0; i < total_AI_Ch; i++)
                    {
                            if (register[i] < 30000)
                            {
                                switch(register_unit[0])
                                {
                                    case 0x06:
                                    case 0x07:
                                    case 0x08:
                                    case 0x09:
                                    case 0x0D:
                                    case 0x1A:
                                        lbAI[i].Text = ((double)register[i] / 1000).ToString("0.000");
                                        break;
                                    case 0x05:
                                    case 0x0A:
                                        lbAI[i].Text = ((double)register[i] / 10000).ToString("0.000");
                                        break;
                                    case 0x0B:
                                        lbAI[i].Text = ((double)register[i] / 10).ToString("0.000");
                                        break;
                                    case 0x60:
                                    case 0x61:
                                    case 0x62:
                                    case 0x63:
                                    case 0x64:
                                    case 0x65:
                                    case 0x66:
                                    case 0x67:
                                    case 0x68:
                                    case 0x69:
                                    case 0x6A:
                                    case 0x6B:
                                    case 0x6C:
                                    case 0x70:
                                    case 0x71:
                                    case 0x72:
                                    case 0x73:
                                    case 0x74:
                                    case 0x75:
                                    case 0x76:
                                    case 0x77:
                                        lbAI[i].Text = ((double)register[i] / 100).ToString("0.000");
                                        break;
                                    default:
                                        break;
                                }
                            }
                            else
                            {
                                switch (register_unit[0])
                                {
                                    case 0x06:
                                    case 0x07:
                                    case 0x08:
                                    case 0x09:
                                    case 0x0D:
                                    case 0x1A:
                                        lbAI[i].Text = "-" + ((double)(65536 - register[i]) / 1000).ToString("0.000");
                                        break;
                                    case 0x05:
                                    case 0x0A:
                                        lbAI[i].Text = "-" + ((double)(65536 - register[i]) / 10000).ToString("0.000");
                                        break;
                                    case 0x60:
                                    case 0x61:
                                    case 0x62:
                                    case 0x63:
                                    case 0x64:
                                    case 0x65:
                                    case 0x66:
                                    case 0x67:
                                    case 0x68:
                                    case 0x69:
                                    case 0x6A:
                                    case 0x6B:
                                    case 0x6C:
                                    case 0x70:
                                    case 0x71:
                                    case 0x72:
                                    case 0x73:
                                    case 0x74:
                                    case 0x75:
                                    case 0x76:
                                    case 0x77:
                                        lbAI[i].Text = ((double)register[i] / 100).ToString("0.000");
                                        break;
                                    default:
                                        break;
                                }
                            }                                                    
                        }
                    }                
                #endregion
                #region AO(4xxxx)
                if (total_AO_Ch > 0)
                {
                    holdingregister = master.ReadHoldingRegisters(slaveID, 64, total_AO_Ch);
                    for (int i = 0; i < total_AO_Ch; i++)
                    {
                            switch (AOunit[i])
                            {
                                case 0:
                                    tbAO[i].Text = ((double)holdingregister[i] / 1000).ToString("0.000");
                                    break;
                                case 1:
                                    tbAO[i].Text = ((double)holdingregister[i] / 1000).ToString("0.000");
                                    break;
                                case 2:
                                    tbAO[i].Text = ((double)holdingregister[i] / 1000).ToString("0.000");
                                    break;
                                case 4:
                                    //AOunits = (holdingregister[i] / 13.107 / 1000).ToString();
                                    tbAO[i].Text = ((double)holdingregister[i] / 1000).ToString("0.000");
                                    break;
                                default:
                                    break;
                            }
                        /*switch (AOunit[i])
                        {
                            case 0:
                                tbAO[i].Text = (holdingregister[i] / 3.27675 / 1000).ToString("0.000");
                                break;
                            case 1:
                                tbAO[i].Text = ((holdingregister[i] / 4.0959375) - +4000 / 1000).ToString("0.000");
                                break;
                            case 2:
                                tbAO[i].Text = (holdingregister[i] / 6.5535 / 1000).ToString("0.000");
                                break;
                            case 4:
                                //AOunits = (holdingregister[i] / 13.107 / 1000).ToString();
                                tbAO[i].Text = (holdingregister[i] / 13.107 / 1000).ToString("0.000");
                                break;
                            default:
                                break;
                        }*/
                    }
                }
                #endregion
            }
            catch (Exception ex)
            {
                Console.WriteLine("Error : " + ex.Message);
            }
        }

        private void tbAO_Click(object sender, EventArgs e)
        {
            Point pi = new Point();
            frmInputValue inputvalue = new frmInputValue();                                    
            ushort index = ushort.Parse(((TextBox)sender).Tag.ToString());
            pi.X = this.tbAO[index].Location.X;
            pi.Y = this.tbAO[index].Location.Y;
            pi = PointToScreen(pi);

            inputvalue.StartPosition = System.Windows.Forms.FormStartPosition.Manual;
            inputvalue.Location = new Point(pi.X , pi.Y);
            //inputvalue.StringValue = ((TextBox)sender).Text;
            inputvalue.ShowDialog();

            if (inputvalue.DialogResult == DialogResult.OK)
            {
                double value = 1000 * inputvalue.Value;
                switch (AOunit[index])
                {
                    case 0:
                        if (value > 20000 || value < 0)
                        {
                            MessageBox.Show("Wrong Value", "ERROR");
                            return;
                        }
                        break;
                    case 1:
                        if (value < 4000 || value > 20000)
                        {
                            MessageBox.Show("Wrong Value", "ERROR");
                            return;
                        }
                        break;
                    case 2:
                        if (value > 10000 || value < 0)
                        {
                            MessageBox.Show("Wrong Value", "ERROR");
                            return;
                        }
                        break;
                    case 4 :
                        if (value > 5000 || value < 0)
                        {
                            MessageBox.Show("Wrong Value", "ERROR");
                            return;
                        }
                        break;
                    default:
                        break;
                }

                ushort aovalue = (ushort)value;

                try
                {
                    master.WriteSingleRegister(slaveID, index, aovalue);
                }
                catch (Exception ex)
                {
                    Console.WriteLine(ex.Message.ToString());
                    MessageBox.Show("Write error.", "ERROR");
                }
                tbAO[index].Text = value.ToString();
            }            
        }

        private void pbDO_Click(object sender, EventArgs e)
        {
            ushort index = ushort.Parse(((PictureBox)sender).Tag.ToString());
            if (((PictureBox)sender).BackColor == Color.DarkRed)
            {
                try
                {
                    master.WriteSingleCoil(slaveID, index, true);
                    ((PictureBox)sender).BackColor = Color.LightGreen;
                }
                catch (Exception ex)
                {
                    Console.WriteLine(ex.Message.ToString());
                    MessageBox.Show("Write error.","ERROR");
                }
            }
            else
            {
                master.WriteSingleCoil(slaveID,index,false);
                ((PictureBox)sender).BackColor = Color.DarkRed;
            }
        }
        /*
        private void panelIO_Paint(object sender, PaintEventArgs e)
        {
            int x = 10;
            int y = 10;
            int vertical_shift = DIAMETER + GAP_CIRCLE_LABEL + LABEL_HEIGHT
                                       + GAP_DI_DO + PitcureBox_HEIGHT + GAP_DI_DO;
            int horizontal_shift = DIAMETER + GAP_HORIZONTAL;

            //total_DI_Ch = int.Parse(cbDI.Items[cbbDICh.SelectedIndex].ToString());
            Brush bs;

            Pen p = new Pen(Color.Black);
            Brush black = new SolidBrush(Color.Black);
            Brush red = new SolidBrush(Color.Red);
            bs = black;

            for (int i = 0; i < total_DI_Ch; i++)
            {
                //if (PACNET.PAC_IO.GetBit(int.Parse(diValue.ToString()), i))
                //    bs = red;
                //else
                //    bs = black;
                e.Graphics.FillEllipse(bs, x + horizontal_shift * (i % 8), y + vertical_shift * (i / 8), DIAMETER, DIAMETER);
            }

        }*/
    }
}
